import 'dart:io';

import 'package:knt_monetize_bloc/knt_monetize_bloc.dart';

import 'ads/data_monetized_repo.dart';
import 'constants.dart';
import 'utils/device_utils.dart';
import 'utils/toast_utils.dart';

Future<FrequentlyAdsBloc> get adsBloc async =>
    FrequentlyAdsBloc(await _admobService, DataMonetizedRepo());

Future<AdmobService> get _admobService async {
  final service = AdmobService(await _admobConfig);
  await service.init();
  return service;
}

Future<AdmobConfig> get _admobConfig async {
  final isIOS = Platform.isIOS;
  final testDeviceIds = <String>[];
  testDeviceIds.add((await fetchDeviceInfo()).id ?? '');
  return AdmobConfig(
    nativeAdUnitId:
        isIOS ? Constants.iosNativeAdsId : Constants.androidNativeAdsId,
    bannerAdUnitId:
        isIOS ? Constants.iosBannerAdsId : Constants.androidBannerAdsId,
    interstitialAdUnitId: isIOS
        ? Constants.iosInterstitialAdsId
        : Constants.androidInterstitialAdsId,
    appVolume: 0.0,
    testDeviceIds: [],
    loggingBuilder: toast,
  );
}
